All of lore.kernel.org
 help / color / mirror / Atom feed
From: "Radim Krčmář" <rkrcmar@redhat.com>
To: kvm@vger.kernel.org
Cc: Paolo Bonzini <pbonzini@redhat.com>,
	Drew Jones <drjones@redhat.com>,
	Laurent Vivier <lvivier@redhat.com>,
	Thomas Huth <thuth@redhat.com>,
	David Hildenbrand <david@redhat.com>
Subject: [kvm-unit-tests PATCH 4/5] scripts/arch-run: fix qemu binary search failure path
Date: Wed, 28 Jun 2017 22:08:56 +0200	[thread overview]
Message-ID: <20170628200857.1718-5-rkrcmar@redhat.com> (raw)
In-Reply-To: <20170628200857.1718-1-rkrcmar@redhat.com>

Doing exit from a subshell won't exit the main shell, so arch-run will
try to continue without a working QEMU if search_qemu_binary() failed.

Also fix error message from search_qemu_binary().

Signed-off-by: Radim Krčmář <rkrcmar@redhat.com>
---
I was thinking about using `set -e` instead, so the "return 2" from
search_qemu_binary() would stop the script without the explicit exit.
It required just four changes to make the script work (resulting in
better diffstat), but would likely complicate future development.

The second alternative would be to call just "search_qemu_binary" and
set the qemu variable from it.  This would allow "exit 2" from
search_qemu_binary() to also exit arch/run, but side-effects on
variables seem worse than the first alternative ...
---
 arm/run               | 3 ++-
 powerpc/run           | 3 ++-
 s390x/run             | 3 ++-
 scripts/arch-run.bash | 6 +++---
 x86/run               | 3 ++-
 5 files changed, 11 insertions(+), 7 deletions(-)

diff --git a/arm/run b/arm/run
index 8d8918a461dc..d7d778fe1645 100755
--- a/arm/run
+++ b/arm/run
@@ -31,7 +31,8 @@ if [ -z "$ACCEL" ]; then
 	fi
 fi
 
-qemu=$(search_qemu_binary)
+qemu=$(search_qemu_binary) ||
+	exit 2
 
 if ! $qemu -machine '?' 2>&1 | grep 'ARM Virtual Machine' > /dev/null; then
 	echo "$qemu doesn't support mach-virt ('-machine virt'). Exiting."
diff --git a/powerpc/run b/powerpc/run
index 3f69386c642a..e43c9fd8063c 100755
--- a/powerpc/run
+++ b/powerpc/run
@@ -28,7 +28,8 @@ if [ -z "$ACCEL" ]; then
 	fi
 fi
 
-qemu=$(search_qemu_binary)
+qemu=$(search_qemu_binary) ||
+	exit 2
 
 if ! $qemu -machine '?' 2>&1 | grep 'pseries' > /dev/null; then
 	echo "$qemu doesn't support pSeries ('-machine pseries'). Exiting."
diff --git a/s390x/run b/s390x/run
index 6df348a93783..ce8d45c2c8fd 100755
--- a/s390x/run
+++ b/s390x/run
@@ -28,7 +28,8 @@ if [ -z "$ACCEL" ]; then
 	fi
 fi
 
-qemu=$(search_qemu_binary)
+qemu=$(search_qemu_binary) ||
+	exit 2
 
 M='-machine s390-ccw-virtio'
 M+=",accel=$ACCEL"
diff --git a/scripts/arch-run.bash b/scripts/arch-run.bash
index 6e429a8748f4..994c1aa9c0cd 100644
--- a/scripts/arch-run.bash
+++ b/scripts/arch-run.bash
@@ -176,9 +176,9 @@ search_qemu_binary ()
 	done
 
 	if [ -z "$qemu" ]; then
-		echo "A QEMU binary was not found."
-		echo "You can set a custom location by using the QEMU=<path> environment variable."
-		exit 2
+		echo "A QEMU binary was not found." >&2
+		echo "You can set a custom location by using the QEMU=<path> environment variable." >&2
+		return 2
 	fi
 	command -v $qemu
 	export PATH=$save_path
diff --git a/x86/run b/x86/run
index a06a7c0f80c8..1099c5ccd609 100755
--- a/x86/run
+++ b/x86/run
@@ -9,7 +9,8 @@ if [ -z "$STANDALONE" ]; then
 	source scripts/arch-run.bash
 fi
 
-qemu=$(search_qemu_binary)
+qemu=$(search_qemu_binary) ||
+	exit 2
 
 if ! ${qemu} -device '?' 2>&1 | grep -F -e \"testdev\" -e \"pc-testdev\" > /dev/null;
 then
-- 
2.13.2

  parent reply	other threads:[~2017-06-28 20:09 UTC|newest]

Thread overview: 18+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-06-28 20:08 [kvm-unit-tests PATCH 0/5] Minor fixes while getting rid of code duplication Radim Krčmář
2017-06-28 20:08 ` [kvm-unit-tests PATCH 1/5] arch/run: simplify copy-paste of the command line Radim Krčmář
2017-06-28 20:08 ` [kvm-unit-tests PATCH 2/5] run_tests: add summary to powerpc and s390 Radim Krčmář
2017-06-29  5:30   ` Thomas Huth
2017-06-29 12:53     ` Radim Krčmář
2017-06-28 20:08 ` [kvm-unit-tests PATCH 3/5] s390+powerpc/run: improve output handling Radim Krčmář
2017-06-28 20:08 ` Radim Krčmář [this message]
2017-06-28 20:46   ` [kvm-unit-tests PATCH 4/5] scripts/arch-run: fix qemu binary search failure path Paolo Bonzini
2017-06-29 12:32     ` Radim Krčmář
2017-06-28 20:08 ` [kvm-unit-tests PATCH 5/5] arch/run: unify accelerator detection Radim Krčmář
2017-06-28 20:48   ` Paolo Bonzini
2017-06-29 12:45     ` Radim Krčmář
2017-06-29 13:46       ` Radim Krčmář
2017-06-29 13:49         ` Paolo Bonzini
2017-06-29 14:28   ` [kvm-unit-tests PATCH v2 " Radim Krčmář
2017-06-29 14:32   ` [kvm-unit-tests PATCH v2 6/5] x86/run: support accelerator controls Radim Krčmář
2017-06-30 10:42     ` Paolo Bonzini
2017-06-29 11:41 ` [kvm-unit-tests PATCH 0/5] Minor fixes while getting rid of code duplication Andrew Jones

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20170628200857.1718-5-rkrcmar@redhat.com \
    --to=rkrcmar@redhat.com \
    --cc=david@redhat.com \
    --cc=drjones@redhat.com \
    --cc=kvm@vger.kernel.org \
    --cc=lvivier@redhat.com \
    --cc=pbonzini@redhat.com \
    --cc=thuth@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.